//
//   Example 6-3.  
//
//  :
//   Learning OpenCV: Computer Vision with the OpenCV Library
//     by Gary Bradski and Adrian Kaehler
//     Published by O'Reilly Media, October 3, 2008
//
// http://robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char* argv[])
{
	IplImage *src=0, *dst=0;

	//     
	char* filename = argc == 2 ? argv[1] : "Image0.jpg";
	//  
	src = cvLoadImage(filename,1);

	printf("[i] image: %s\n", filename);
	assert( src != 0 );

	//  
	cvNamedWindow( "image", 1 );
	cvShowImage( "image", src );

	// 
	CvPoint2D32f srcQuad[4], dstQuad[4];
	//  
	CvMat* warp_matrix = cvCreateMat(3,3,CV_32FC1);

	//  
	dst = cvCloneImage(src);

	//  
	srcQuad[0].x = 0;           //src Top left
	srcQuad[0].y = 0;
	srcQuad[1].x = src->width - 1;  //src Top right
	srcQuad[1].y = 0;
	srcQuad[2].x = 0;           //src Bottom left
	srcQuad[2].y = src->height - 1;
	srcQuad[3].x = src->width - 1;  //src Bot right
	srcQuad[3].y = src->height - 1;
	//- - - - - - - - - - - - - -//
	dstQuad[0].x = src->width*0.05;  //dst Top left
	dstQuad[0].y = src->height*0.33;
	dstQuad[1].x = src->width*0.9;  //dst Top right
	dstQuad[1].y = src->height*0.25;
	dstQuad[2].x = src->width*0.2;  //dst Bottom left
	dstQuad[2].y = src->height*0.7;      
	dstQuad[3].x = src->width*0.8;  //dst Bot right
	dstQuad[3].y = src->height*0.9;

	//   
	cvGetPerspectiveTransform(srcQuad,dstQuad,warp_matrix);
	//  
	cvWarpPerspective(src,dst,warp_matrix);

	// 
	cvNamedWindow( "cvWarpPerspective", 1 );
	cvShowImage( "cvWarpPerspective", dst );

	//   
	cvWaitKey(0);

	//  
	cvReleaseMat(&warp_matrix);

	cvReleaseImage(&src);
	cvReleaseImage(&dst);

	//  
	cvDestroyAllWindows();
	return 0;
}
